
{$APPTYPE GUI}{$MODE DELPHI}

program DemoVirtualLight;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_VirtualLight;

//const
 
//type
  
var 
  pos:TGLVector;

   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(3,3, 0,3, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 3,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure Scena;
begin
  TextureSelectID(1);
  glPushMatrix; // superiore
  glTranslatef(0,10,0); 
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
  glPopMatrix; 
  glPushMatrix; // inferiore
  glTranslatef(0,-10,0); 
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
  glPopMatrix;  
  TextureSelectID(0);
  glPushMatrix; // sinistra
  glTranslatef(-10,0,0); 
  glRotatef(90,1,0,0);  
  glRotatef(90,0,0,1);  
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
  glPopMatrix;  
  glPushMatrix; // destra
  glTranslatef(10,0,0);
  glRotatef(90,1,0,0);    
  glRotatef(90,0,0,1); 
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
  glPopMatrix;  
  glPushMatrix; // posteriore
  glTranslatef(0,0,-10); 
  glRotatef(90,1,0,0); 
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
  glPopMatrix;    
  
  glPushMatrix;
  glTranslatef(-2,-8,3);    
  glRotatef(90,1,0,0); 
  Sfera(0,0,0, 2,18,18, 1/3);
  glPopMatrix; 
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('stoneblocks.bmp',0);
  TextureLoadID('pavement.bmp',1);
  //TextureLoadTGAID('Font.tga',0);
  
end;
begin 

  OpenGL_Texture();
  
  
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  if SetglKey('A')then pos.x:=pos.x-1;
  if SetglKey('D')then pos.x:=pos.x+1;
  if SetglKey('W')then pos.y:=pos.y+1;
  if SetglKey('S')then pos.y:=pos.y-1;
  if SetglKey('Z')then pos.z:=pos.z-1;
  if SetglKey('X')then pos.z:=pos.z+1;  
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-1,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(15,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1);  

  AddVirtualSpotLight(Scena,0,5,-10, -90,0, 1,1,1, 15,4,16, 6);
  AddVirtualPointLight(Scena,-10,0,2.5, 1,0,0, 12,16, 4); 
  AddVirtualPointLight(Scena,10,-10,-10.5, 1,1,0, 5,16, 4);   
  AddVirtualPointLight(Scena,-10+pos.x,pos.y,-10.5+pos.z, 0,1,0, 5,16, 4); 
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('DemoTutorial Luci virtuali - A\D,W\S,Z\X movimento luce verde', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
